unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TLHELP32, PSAPI, StdCtrls, ComCtrls, ExtCtrls;

type
    //  vZXƂɌĂяoĂق֐^`
    TCancel = Boolean;
    TProcessFound = function(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string;
                    const Data: TObject): TCancel of object;
    TModuleFound = function(const ModuleEntry: TModuleEntry32;
                    const Err: Boolean; const ErrText: string;
                    const Data: TObject): TCancel of object;
type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TreeProcess: TTreeView;
    TreeModule: TTreeView;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  private
    FPrivilegeChanged: Boolean;
    FStrBuf: TStringList;
    function ProcessFound(const ProcessEntry: TProcessEntry32;
                        const Err: Boolean; const ErrText: string;
                        const Data: TObject): TCancel;
    function ModuleFound(const ModuleEntry: TModuleEntry32;
                        const Err: Boolean; const ErrText: string;
                        const Data: TObject): TCancel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    NTPrivilege, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  vZXꗗ擾
//  http://nienie.com/~masapico/api_sample_ps05_c.html
//  http://nienie.com/~masapico/api_EnumProcesses.html
//  http://support.microsoft.com/default.aspx?scid=kb;ja;JP175030
//  http://www.borland.co.jp/qanda/delphi/d0003287.html
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=13
procedure SnapShotProcess(CallBack: TProcessFound; const CallBackVar: TObject);
var
    SnapShot: THandle;
    PE32: TProcessEntry32;
begin
    //  \̂̏
    FillChar(PE32, SizeOf(PE32), 0);
    PE32.dwSize := SizeOf(PE32);

    try
        // VXȅ̃XibvVbgƂ
        SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

        //  ꍇ
        if (SnapShot <> INVALID_HANDLE_VALUE) then
        begin
            try
                // ŏ̃vZX̌
                if Process32First(SnapShot, PE32) then
                begin
                    //  ʒm
                    repeat
                        if CallBack(PE32, False, '', CallBackVar) then Break;

                    // ̃vZX̌
                    until not Process32Next(SnapShot, PE32);
                end
                //  s
                else CallBack(PE32, False, '', CallBackVar);
            finally
                CloseHandle(SnapShot);
            end;
        end
        //  sꍇ
        else
        begin
            CallBack(PE32, True, SysErrorMessage(GetLastError()), CallBackVar);
        end;
    except
        on E: Exception do CallBack(PE32, True, E.Message, CallBackVar);
    end;
end;

//-----------------------------------------------------------------------------
//  W[ꗗ擾
procedure SnapShotModule(const ProcessEntry: TProcessEntry32;
                        CallBack: TModuleFound; const CallBackVar: TObject);
var
    SnapShot: THandle;
    ME32: TModuleEntry32;
begin
    //  \̂̏
    FillChar(ME32, SizeOf(ME32), 0);
    ME32.dwSize := SizeOf(ME32);

    try
        // vZX̎gpĂ郂W[
        SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, ProcessEntry.th32ProcessID);

        //  ꍇ
        if (SnapShot <> INVALID_HANDLE_VALUE) then
        begin
            try
                // ŏ̃W[̌
                if Module32First(SnapShot, ME32) then
                begin
                    //  ʒm
                    repeat
                        if CallBack(ME32, False, '', CallBackVar) then Break;

                    // ̃W[̌
                    until not Module32Next(SnapShot, ME32);
                end
                //  s
                else CallBack(ME32, False, '', CallBackVar);
            finally
                CloseHandle(SnapShot);
            end;
        end
        //  sꍇ
        else
        begin
            CallBack(ME32, True, SysErrorMessage(GetLastError()), CallBackVar);
        end;
    except
        on E: Exception do CallBack(ME32, True, E.Message, CallBackVar);
    end;
end;

//-----------------------------------------------------------------------------
//  Programmer's Road
//  http://ag5.net/~prgroad/programming/visualc_mfc/NoryDll.html
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);

    FStrBuf := TStringList.Create();

    //  擾(vZX̃fobO)
    FPrivilegeChanged := NTSetPrivilege(SE_DEBUG_NAME, True);

    //  ÑvZX
    TreeProcess.Items.Clear();
    TreeModule.Items.Clear();
    FStrBuf.Clear();
    SnapShotProcess(ProcessFound, nil);
    TreeProcess.AlphaSort(True);
    TreeModule.AlphaSort(True);
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  
    if (FPrivilegeChanged) then NTSetPrivilege(SE_DEBUG_NAME, False);

    FStrBuf.Free();
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  vZX擾
//  http://www.microsoft.com/japan/msdn/library/default.asp?url=/japan/msdn/library/ja/jpperfmo/html/_win32_GetProcessMemoryInfo.asp
//  http://www.ccn.aitai.ne.jp/~ccc/C++/Psapi.txt
//  http://nienie.com/~masapico/api_EmptyWorkingSet.html
function TForm1.ProcessFound(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string;
                    const Data: TObject): TCancel;
var
    LNode: TTreeNode;
    LPath: String;
begin
    if (not Err) then
    begin
        LPath := ProcessEntry.szExeFile;
        LNode := TreeProcess.Items.Add(nil, LPath);

        //  W[
        SnapShotModule(ProcessEntry, ModuleFound, LNode);
    end;

    //  SvZX񋓂
    Result := False;
end;

//-----------------------------------------------------------------------------
//  W[擾
function TForm1.ModuleFound(const ModuleEntry: TModuleEntry32;
                    const Err: Boolean; const ErrText: string;
                    const Data: TObject): TCancel;
var
    LTree: TTreeView;
    LNode: TTreeNode;
    LPath: String;
    LIndex: Integer;
    LNode2: TTreeNode;
begin
    if (not Err) then
    begin
        LPath := ModuleEntry.szExePath;
        LNode := TTreeNode(Data);
        if (LNode <> nil) then
        begin
            LTree := TTreeView(LNode.TreeView);

            if (SameFileName(ExtractFileName(LPath), LNode.Text)) then
            begin
                LNode.Text := LPath;
            end
            else if (not SameText(ExtractFileExt(LPath), '.exe')) then
            begin
                LTree.Items.AddChild(LNode, LPath);

                //  DLL͂łɃXgɂ邩
                LIndex := FStrBuf.IndexOf(LPath);
                if (LIndex = -1) then
                begin
                    //  c[ɒǉ
                    LNode2 := TreeModule.Items.Add(nil, LPath);

                    //  Xgɂǉ
                    FStrBuf.AddObject(LPath, LNode2);

                    //  gpEXEǉ
                    TreeModule.Items.AddChild(LNode2, LNode.Text);
                end
                else
                begin
                    LNode2 := TTreeNode(FStrBuf.Objects[LIndex]);
                    TreeModule.Items.AddChild(LNode2, LNode.Text);
                end;
            end;
        end;
    end;

    //  vZX̖{̂EXÊ
    //Result := True;

    //  SW[񋓂
    Result := False;
end;

//-----------------------------------------------------------------------------
//  ŐV̏ԂɍXV
procedure TForm1.Button2Click(Sender: TObject);
begin
    TreeProcess.Items.Clear();
    TreeModule.Items.Clear();
    FStrBuf.Clear();
    SnapShotProcess(ProcessFound, nil);
    TreeProcess.AlphaSort(True);
    TreeModule.AlphaSort(True);
end;

end.
